// Auto-generated. Do not edit!

// (in-package gcloud_speech_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class SpeechToTextGoal {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.hints = null;
      this.max_alternatives = null;
      this.listen_duration_sec = null;
      this.max_recognition_duration_sec = null;
      this.suppress_interim_results = null;
    }
    else {
      if (initObj.hasOwnProperty('hints')) {
        this.hints = initObj.hints
      }
      else {
        this.hints = [];
      }
      if (initObj.hasOwnProperty('max_alternatives')) {
        this.max_alternatives = initObj.max_alternatives
      }
      else {
        this.max_alternatives = 0;
      }
      if (initObj.hasOwnProperty('listen_duration_sec')) {
        this.listen_duration_sec = initObj.listen_duration_sec
      }
      else {
        this.listen_duration_sec = 0;
      }
      if (initObj.hasOwnProperty('max_recognition_duration_sec')) {
        this.max_recognition_duration_sec = initObj.max_recognition_duration_sec
      }
      else {
        this.max_recognition_duration_sec = 0;
      }
      if (initObj.hasOwnProperty('suppress_interim_results')) {
        this.suppress_interim_results = initObj.suppress_interim_results
      }
      else {
        this.suppress_interim_results = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SpeechToTextGoal
    // Serialize message field [hints]
    bufferOffset = _arraySerializer.string(obj.hints, buffer, bufferOffset, null);
    // Serialize message field [max_alternatives]
    bufferOffset = _serializer.int32(obj.max_alternatives, buffer, bufferOffset);
    // Serialize message field [listen_duration_sec]
    bufferOffset = _serializer.int32(obj.listen_duration_sec, buffer, bufferOffset);
    // Serialize message field [max_recognition_duration_sec]
    bufferOffset = _serializer.int32(obj.max_recognition_duration_sec, buffer, bufferOffset);
    // Serialize message field [suppress_interim_results]
    bufferOffset = _serializer.bool(obj.suppress_interim_results, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SpeechToTextGoal
    let len;
    let data = new SpeechToTextGoal(null);
    // Deserialize message field [hints]
    data.hints = _arrayDeserializer.string(buffer, bufferOffset, null)
    // Deserialize message field [max_alternatives]
    data.max_alternatives = _deserializer.int32(buffer, bufferOffset);
    // Deserialize message field [listen_duration_sec]
    data.listen_duration_sec = _deserializer.int32(buffer, bufferOffset);
    // Deserialize message field [max_recognition_duration_sec]
    data.max_recognition_duration_sec = _deserializer.int32(buffer, bufferOffset);
    // Deserialize message field [suppress_interim_results]
    data.suppress_interim_results = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.hints.forEach((val) => {
      length += 4 + val.length;
    });
    return length + 17;
  }

  static datatype() {
    // Returns string type for a message object
    return 'gcloud_speech_msgs/SpeechToTextGoal';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '62642f8234450646d11f3cec1403c25a';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    # Goal definition
    # Equivalent to google.cloud.speech.v1.StreamingRecognitionConfig. See also:
    # https://cloud.google.com/speech/reference/rpc/google.cloud.speech.v1#streamingrecognitionconfig
    
    # A list of strings containing words and phrases "hints" so that the speech
    # recognition is more likely to recognize them. This can be used to improve the
    # accuracy for specific words and phrases, for example, if specific commands are
    # typically spoken by the user. This can also be used to add additional words to
    # the vocabulary of the recognizer.
    string[] hints
    
    # Maximum number of recognition hypotheses to be returned. Specifically, the
    # maximum number of RecognitionHypothesis messages within each
    # SpeechToTextFeedback. The server may return fewer than max_alternatives. Valid
    # values are 0-30. A value of 0 or 1 will return a maximum of one. If omitted,
    # will return a maximum of one.
    int32 max_alternatives
    
    # Maximum listening duration. The recognizer will start listening immediately,
    # and will stop listening after "listen_duration_sec" seconds. If 0 or omitted,
    # will use an internal default value (14 seconds).
    int32 listen_duration_sec
    
    # Maximum recognition duration. The recognizer will start counting down
    # immediately, and after max_recognition_duration_sec seconds it will return no
    # matter whether there is a recognition result. If 0 or omitted, will use
    # a default value: listen_duration_sec + 2.
    int32 max_recognition_duration_sec
    
    
    # If false or omitted, interim results (tentative hypotheses) may be returned as
    # they become available (these interim results are indicated with the
    # is_portion_final=false flag). If true, only is_portion_final=true result(s)
    # are returned.
    bool suppress_interim_results
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SpeechToTextGoal(null);
    if (msg.hints !== undefined) {
      resolved.hints = msg.hints;
    }
    else {
      resolved.hints = []
    }

    if (msg.max_alternatives !== undefined) {
      resolved.max_alternatives = msg.max_alternatives;
    }
    else {
      resolved.max_alternatives = 0
    }

    if (msg.listen_duration_sec !== undefined) {
      resolved.listen_duration_sec = msg.listen_duration_sec;
    }
    else {
      resolved.listen_duration_sec = 0
    }

    if (msg.max_recognition_duration_sec !== undefined) {
      resolved.max_recognition_duration_sec = msg.max_recognition_duration_sec;
    }
    else {
      resolved.max_recognition_duration_sec = 0
    }

    if (msg.suppress_interim_results !== undefined) {
      resolved.suppress_interim_results = msg.suppress_interim_results;
    }
    else {
      resolved.suppress_interim_results = false
    }

    return resolved;
    }
};

module.exports = SpeechToTextGoal;
